Token delegate
curl --request POST \
--url https://api.hyperliquid.xyz/exchange \
--header 'Content-Type: application/json' \
--data '
{
"action": {
"type": "tokenDelegate",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"validator": "0x1234567890abcdef1234567890abcdef12345678",
"wei": 1000000000000000000,
"isUndelegate": false,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": null
}
'import requests
url = "https://api.hyperliquid.xyz/exchange"
payload = {
"action": {
"type": "tokenDelegate",
"hyperliquidChain": "Mainnet",
"signatureChainId": "0xa4b1",
"validator": "0x1234567890abcdef1234567890abcdef12345678",
"wei": 1000000000000000000,
"isUndelegate": False,
"nonce": 1705234567890
},
"nonce": 1705234567890,
"signature": {
"r": "0x0000000000000000000000000000000000000000000000000000000000000000",
"s": "0x0000000000000000000000000000000000000000000000000000000000000000",
"v": 27
},
"vaultAddress": None
}
headers = {"Content-Type": "application/json"}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'Content-Type': 'application/json'},
body: JSON.stringify({
action: {
type: 'tokenDelegate',
hyperliquidChain: 'Mainnet',
signatureChainId: '0xa4b1',
validator: '0x1234567890abcdef1234567890abcdef12345678',
wei: 1000000000000000000,
isUndelegate: false,
nonce: 1705234567890
},
nonce: 1705234567890,
signature: {
r: '0x0000000000000000000000000000000000000000000000000000000000000000',
s: '0x0000000000000000000000000000000000000000000000000000000000000000',
v: 27
},
vaultAddress: null
})
};
fetch('https://api.hyperliquid.xyz/exchange', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"status": "<string>",
"response": {}
}Hyperliquid node API
tokenDelegate | Hyperliquid exchange
Delegates tokens to a validator for staking on Hyperliquid. Hyperliquid exchange developers can call tokenDelegate via Chainstack.
POST
/
exchange
Token delegate
You can only use this endpoint on the official Hyperliquid public API. It is not available through Chainstack, as the open-source node implementation does not support it yet. See Hyperliquid methods for the full availability breakdown.
This endpoint requires signature authentication. See our comprehensive Authentication via Signatures guide for implementation details.
Get your own node endpoint todayStart for free and get your app to production levels immediately. No credit card required.You can sign up with your GitHub, X, Google, or Microsoft account.
Parameters
Required parameters
action(object, required) — The action object containing:type(string) — Must be"tokenDelegate"validator(string) — Validator address to delegate toamount(string) — Amount to delegateisUndelegate(boolean) — True to undelegate, false to delegate
nonce(number, required) — Current timestamp in milliseconds (must be recent)signature(object, required) — EIP-712 signature of the action
Optional parameters
vaultAddress(string, optional) — Address when trading on behalf of a vault or subaccount
Returns
Returns an object with the action status:status—"ok"if request processedresponse— Contains action result data
Example request
curl -X POST https://api.hyperliquid.xyz/exchange \
-H "Content-Type: application/json" \
-d '{
"action": {"type": "tokenDelegate"},
"nonce": 1234567890123,
"signature": {...}
}'
from eth_account import Account
from hyperliquid.exchange import Exchange
from hyperliquid.utils import constants
# Wallet that signs the EIP-712 action.
wallet = Account.from_key("0x...")
# Public Hyperliquid mainnet endpoint (this method is public-only).
exchange = Exchange(wallet, constants.MAINNET_API_URL)
# wei is the amount in token units * 1e8; is_undelegate=False delegates.
result = exchange.token_delegate(
validator="0x...",
wei=1 * 10**8,
is_undelegate=False,
)
print(result)
import { ExchangeClient, HttpTransport } from "@nktkas/hyperliquid";
import { privateKeyToAccount } from "viem/accounts";
// Wallet that signs the EIP-712 action.
const wallet = privateKeyToAccount("0x...");
// Public Hyperliquid mainnet endpoint (this method is public-only).
const transport = new HttpTransport();
const exchange = new ExchangeClient({ transport, wallet });
// wei is the amount in token units * 1e8; isUndelegate: false delegates.
const result = await exchange.tokenDelegate({
validator: "0x...",
wei: 1 * 1e8,
isUndelegate: false,
});
console.log(result);
Use case
- Token delegate — Delegates tokens to a validator for staking on Hyperliquid.
Always ensure your system clock is synchronized. Nonce must be within a reasonable time window of the current server time or the request will be rejected.
Body
application/json
Last modified on June 24, 2026
Was this page helpful?
⌘I